package top.ninwoo.hadoop.api.service;

import top.ninwoo.hadoop.api.po.*;

import java.awt.image.BufferedImage;

public interface HadoopComService {

    /**
     * 文件切片
     * @param bufferedImage  图片
     * @param sliceNum 切片数量
     * @return
     */
    SplitResult fileSplit(BufferedImage bufferedImage, int sliceNum);
    //SplitResult fileSplit(String fileName, int sliceNum);

    /**
     * 切片处理
     * @param splitResult
     * @return
     */
    ComputingResult sliceComputing(SplitResult splitResult);

    /**
     * 切片聚合接口
     * @param computingResult
     *  @param sliceNum 切片数量
     * @return
     */
    MergeResult sliceMerge(ComputingResult computingResult, int sliceNum);

    /**
     * 切片发送服务
     * @param targetIp
     * @param fileSlice
     * @return
     */
    SendResult sendFileSlice(String targetIp, FileSlice fileSlice);

    /**
     * 指定地址的ip获取切片
     * @param targetIp
     * @param fileId
     * @param sliceId
     * @return
     */
    FileSlice getFileSlice(String targetIp, Long fileId, int sliceId);
    
}
