package top.ninwoo.hadoop.utils;

import org.springframework.stereotype.Service;
import top.ninwoo.hadoop.api.po.*;
import top.ninwoo.hadoop.api.service.HadoopComService;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

@Service
public class FileServiceImplement implements HadoopComService {


    ImageToArrayUtils itau = new ImageToArrayUtils();
    // 图片切分
    @Override
    public SplitResult fileSplit(BufferedImage bufferedImage, int sliceNum) {

/*        // 读入大图
        BufferedImage image = itau.readImage(srcOrig);*/
        // 分割图片，并将其转化为byte数组
        List<byte[]> byteList  = itau.imageSplit(bufferedImage,sliceNum);

        List<FileSlice> fileSliceList = new ArrayList<>();
        for (int i = 0; i < byteList.size(); i++) {
            FileSlice fileSlice = new FileSlice();
            fileSlice.setFileId(1L);//文件的唯一标识
            fileSlice.setSliceId(i);//数据碎片的id
            fileSlice.setFileBytes(byteList.get(i));//文件的比特数据
            fileSliceList.add(fileSlice);
        }
        
        //对分割后的碎片，按照其数据量大小排序
/*        for (int i = 0; i < fileSliceList.size()-1; i++) {
            for (int j = 0; j < fileSliceList.size()-i-1; j++) {
                if (fileSliceList.get(j).getFileBytes().length<fileSliceList.get(j+1).getFileBytes().length) {
                 fileSliceList.set(j,fileSliceList.get(j+1));
                 fileSliceList.set(j+1,fileSliceList.get(j));
                }
            }
        }*/
        SplitResult splitResult = new SplitResult();
        splitResult.setFileSliceList(fileSliceList);
        return splitResult;
    }

    //小图片处理---灰度处理
    @Override
    public ComputingResult sliceComputing(SplitResult splitResult){

        List<FileSlice> fileSliceList = splitResult.getFileSliceList();
        List<byte[]> grayByteList = itau.grayImage(fileSliceList);
        //把每个小图片转为一个byte数组
        //List<byte[]> grayByteList = itau.imageToByte(grayImage);
        List<FileSliceComputing> grayfileSliceList = new ArrayList<>();
        for (int i = 0; i < grayByteList.size(); i++) {
            FileSliceComputing fileSliceComputing = new FileSliceComputing();
            fileSliceComputing.setFileId(1L);//文件的唯一标识
            fileSliceComputing.setSliceId(i);//数据碎片的id
            fileSliceComputing.setFileBytes(grayByteList.get(i));//文件的比特数据
            grayfileSliceList.add(fileSliceComputing);
        }
        ComputingResult computingResult = new ComputingResult();
        computingResult.setFileSliceComputingList(grayfileSliceList);
        return computingResult;
    }

    @Override
    public MergeResult sliceMerge(ComputingResult computingResult, int sliceNum) {
        List<FileSliceComputing> grayfileSliceList = computingResult.getFileSliceComputingList();
        BufferedImage finalImg = itau.imageMerge(grayfileSliceList, sliceNum);

        MergeResult mergeResult = new MergeResult();
        mergeResult.setImages(finalImg);
        return mergeResult;
    }

    public SendResult sendFileSlice(String targetIp, FileSlice fileSlice) {
        return null;
    }

    public FileSlice getFileSlice(String targetIp, Long fileId, int sliceId) {
        return null;
    }



}
